// screensaver.h : main header file for the SCREENSAVER application
//

#if !defined(AFX_SCREENSAVER_H__F42F12B4_728D_11D3_B3DD_00A0C90F8EDC__INCLUDED_)
#define AFX_SCREENSAVER_H__F42F12B4_728D_11D3_B3DD_00A0C90F8EDC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

/////////////////////////////////////////////////////////////////////////////
// CScreensaverApp:
//
// This ABC forms the basis of the Screensaver skeleton.  You should derive
// a concrete class from this base and implement the pure virtual functions
// to carry out the necessary implementation of your screensaver.
//
class CScreensaverApp : public CWinApp
{
public:

	virtual ~CScreensaverApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScreensaverApp)
public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

public:
	//{{AFX_MSG(CScreensaverApp)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:

	// We can only be created by concrete classes
	CScreensaverApp();

	// Concretes of this class MUST override these pure virtuals.
	// The virtuals are broken down into groups based upon their
	// requirement.

	// These are for fullscreen operation.
	// Initialise fullscreen mode (typically creates a window)
	// and return the HWND.  If there is an error, return NULL.
	// The render call is made once per frame.
	// If the monitor power is lost, the doRestoreFullscreen()
	// method is called.  This should re-create any device
	// objects as required.
	virtual HWND doCreateFullscreen() = 0;
	virtual void doRenderFullscreen() = 0;
	virtual void doDestroyFullscreen() = 0;
	virtual void doRestoreFullscreen() = 0;

	// These are for running any configuration dialog
	// and for the persistence mechanism for screensaver
	// settings.  In running the configuration, the
	// client should automatically persist any settings
	// it needs.
	virtual void doRunConfiguration() = 0;

	// These are for running the preview mode.
	// The client should use the parent HWND to
	// create a child window of the same dimensions
	// and render to that target.  It is ASSUMED
	// that this will be a windowed and not fullscreen
	// render target.
	// The render call is made once per frame.
	// If the monitor power is lost, the doRestorePreview()
	// method is called.  This should re-create any device
	// objects as required.
	virtual HWND doCreatePreview( HWND hParentWnd ) = 0;
	virtual void doRenderPreview() = 0;
	virtual void doDestroyPreview() = 0;
	virtual void doRestorePreview() = 0;

	// Return the name to use for the registry stub key.
	// Typically, this would be the name of the company.
	virtual LPCTSTR	applicationRegistryKey() const = 0;

private:

	// Canonical form revoked
	CScreensaverApp( const CScreensaverApp &copyMe );
	CScreensaverApp &operator =( const CScreensaverApp &copyMe );

	// Internal methods
	void	runScreensaver();
	void	runConfiguration();
	void	runPreview( HWND hParentWnd );
	void	runChangePassword();
	bool	verifyPassword( HWND hParentWnd );
	HWND	createHelperWindow();

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCREENSAVER_H__F42F12B4_728D_11D3_B3DD_00A0C90F8EDC__INCLUDED_)
